<?php

namespace App\Livewire\Studio\Master\Warehouse;

use App\Livewire\Forms\Studio\Master\WarehouseForm;
use App\Models\Warehouse as WarehouseModel;
use App\Traits\Authorization\WithAuthorization;
use App\Traits\Components\WithCloseModal;
use App\Traits\Components\WithConfirmation;
use App\Traits\Components\WithToast;
use App\Traits\Notification\WithSubscribeNotification;
use App\Traits\Utilities\WithUpdatedData;
use Flux\Flux;
use Illuminate\Contracts\View\View;
use Livewire\Attributes\On;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Gudang')]
class Index extends Component
{
    use WithAuthorization, WithCloseModal, WithConfirmation, WithSubscribeNotification, WithToast, WithUpdatedData;

    public WarehouseForm $form;

    public string $method = 'create';

    public string $modalTitle = '';

    public function create(): void
    {
        $this->canOrAbort('create warehouse');

        $this->form->store();

        $this->dispatch('refreshDatatable');

        $this->toast('Gudang berhasil ditambahkan.');

        Flux::modals()->close();
    }

    public function update(): void
    {
        $this->canOrAbort('update warehouse');

        $this->form->update();

        $this->dispatch('refreshDatatable');

        $this->toast('Gudang berhasil diperbarui.');

        Flux::modals()->close();
    }

    public function delete(WarehouseModel $warehouse): void
    {
        $this->canOrAbort('delete warehouse');

        $this->form->warehouse = $warehouse;

        $this->form->delete();

        $this->dispatch('refreshDatatable');

        $this->toast('Gudang berhasil dihapus.');

        Flux::modals()->close();
    }

    #[On('modal:open')]
    public function openModal(string $method, string $modalTitle, ?string $id = null): void
    {
        $this->resetValidation();
        $this->resetErrorBag();

        $this->method = $method;
        $this->modalTitle = $modalTitle;

        $id && $this->form->setWarehouse(WarehouseModel::byHashOrFail($id));
    }

    public function render(): View
    {
        return view('livewire.studio.master.warehouse.index', [
            'pageTitle' => 'Gudang',
        ]);
    }
}
